# coding: utf-8

"""
    osparc.io public API

    osparc-simcore public API specifications  # noqa: E501

    The version of the OpenAPI document: 0.7.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from osparc_client.configuration import Configuration


class File(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'filename': 'str',
        'content_type': 'str',
        'checksum': 'str',
        'e_tag': 'str'
    }

    attribute_map = {
        'id': 'id',
        'filename': 'filename',
        'content_type': 'content_type',
        'checksum': 'checksum',
        'e_tag': 'e_tag'
    }

    def __init__(self, id=None, filename=None, content_type=None, checksum=None, e_tag=None, local_vars_configuration=None):  # noqa: E501
        """File - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._filename = None
        self._content_type = None
        self._checksum = None
        self._e_tag = None
        self.discriminator = None

        self.id = id
        self.filename = filename
        if content_type is not None:
            self.content_type = content_type
        if checksum is not None:
            self.checksum = checksum
        if e_tag is not None:
            self.e_tag = e_tag

    @property
    def id(self):
        """Gets the id of this File.  # noqa: E501

        Resource identifier  # noqa: E501

        :return: The id of this File.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this File.

        Resource identifier  # noqa: E501

        :param id: The id of this File.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def filename(self):
        """Gets the filename of this File.  # noqa: E501

        Name of the file with extension  # noqa: E501

        :return: The filename of this File.  # noqa: E501
        :rtype: str
        """
        return self._filename

    @filename.setter
    def filename(self, filename):
        """Sets the filename of this File.

        Name of the file with extension  # noqa: E501

        :param filename: The filename of this File.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and filename is None:  # noqa: E501
            raise ValueError("Invalid value for `filename`, must not be `None`")  # noqa: E501

        self._filename = filename

    @property
    def content_type(self):
        """Gets the content_type of this File.  # noqa: E501

        Guess of type content [EXPERIMENTAL]  # noqa: E501

        :return: The content_type of this File.  # noqa: E501
        :rtype: str
        """
        return self._content_type

    @content_type.setter
    def content_type(self, content_type):
        """Sets the content_type of this File.

        Guess of type content [EXPERIMENTAL]  # noqa: E501

        :param content_type: The content_type of this File.  # noqa: E501
        :type: str
        """

        self._content_type = content_type

    @property
    def checksum(self):
        """Gets the checksum of this File.  # noqa: E501

        SHA256 hash of the file's content  # noqa: E501

        :return: The checksum of this File.  # noqa: E501
        :rtype: str
        """
        return self._checksum

    @checksum.setter
    def checksum(self, checksum):
        """Sets the checksum of this File.

        SHA256 hash of the file's content  # noqa: E501

        :param checksum: The checksum of this File.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                checksum is not None and not re.search(r'^[a-fA-F0-9]{64}$', checksum)):  # noqa: E501
            raise ValueError(r"Invalid value for `checksum`, must be a follow pattern or equal to `/^[a-fA-F0-9]{64}$/`")  # noqa: E501

        self._checksum = checksum

    @property
    def e_tag(self):
        """Gets the e_tag of this File.  # noqa: E501

        S3 entity tag  # noqa: E501

        :return: The e_tag of this File.  # noqa: E501
        :rtype: str
        """
        return self._e_tag

    @e_tag.setter
    def e_tag(self, e_tag):
        """Sets the e_tag of this File.

        S3 entity tag  # noqa: E501

        :param e_tag: The e_tag of this File.  # noqa: E501
        :type: str
        """

        self._e_tag = e_tag

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, File):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, File):
            return True

        return self.to_dict() != other.to_dict()
